/* Costruisci una lista per inserimenti in testa,
   poi fino alla distruzione della lista, cancella la prima
   occorrenza di un valore dato. */
#include <stdio.h>
#include <stdlib.h>


typedef struct s_elemento {
  int chiave;
  struct s_elemento *prox;
} elemento;

/* Stampa la lista: la percorre,
   stampando ogni volta la chiave del nodo
   corrente*/
void stampa(elemento *p)
{
   while ( p != NULL )  
   {
     printf("%d ", p->chiave);
     p = p->prox;
   }
   printf("\n");
}

/* Cancella. NOTA questa funzione ha come input 
   un PUNTATORE alla testa della lista. Questo
   perche' la cancellazione puo' alterare la
   testa. Si preferisce usare un puntatore invece
   della sintassi 
        testa = cancella(testa, .. )
   poiche' la chiamata deve anche ritornare un valore
   intero che dica se la cancellazione ha avuto
   effetto o meno (cioe' se "elem" e' contenuto
   nella lista. */
int cancella( elemento **testap, int elem )
{
   elemento *p = *testap;
   elemento *prev = NULL;
   /* Scorre fino alla prima occorrenza di elem
      o al termine della lista. */
   while ( p != NULL && p->chiave != elem )
   {
     prev = p; 
     p = p->prox;
   }
   /* Non trovato: non cambia niente. */
   if ( p == NULL ) 
      return 0;

   if ( prev == NULL ) /* Cancellazione testa! */
      *testap = p->prox;
   else
      prev->prox = p->prox;
   free (p);

   return 1;
}
   

main()
{
   int N, i, elem;
   elemento *lista = NULL;

   scanf("%d", &N);
   for ( i = 0; i < N; i++ ) 
   {
     scanf("%d", &elem );
     lista = insCoda ( lista, elem );
   }

   stampa(lista);
   
   while ( N > 0 ) 
   {
      scanf("%d", &elem);
      if ( cancella ( &lista, elem ) )
         N--;
      stampa(lista);
   }
}
