/* La Move-To-Front */
#include <stdio.h>
#include <stdlib.h>

typedef struct s_ele { 
   struct s_ele *prec;
   int chiave;
   struct s_ele *prox;
} elemento;


/* Crea un elemento della lista doppiamente connessa
   con i valori dati. */
elemento *crea ( elemento *prec, int chiave, elemento *prox )
{
    elemento * nuovo = malloc(sizeof(elemento));
    nuovo->prec = prec; 
    nuovo->chiave = chiave;
    nuovo->prox = prox;
    return nuovo;
}

/* Legge l'intera lista. */
elemento *leggi_lista ( int N ) 
{
   int i, val;
   elemento *testa = NULL;
   elemento *coda = NULL;
   elemento *nuovo;
   for ( i = 0; i < N; i++ ) 
   {
     scanf("%d", &val ); 
     
     nuovo = crea(coda, val, NULL );

     if ( testa == NULL ) 
        testa = coda = nuovo;
     else 
     {
        coda->prox = nuovo;
        coda = coda->prox;
      }
   }

   return testa;
}


/* Move to front. */
int mtf ( elemento **testaptr, int x )
{
    elemento *p = *testaptr;
    int conta = 0;
  
    /* 1) Contiamo le posizioni dalla testa per "x", 
       se esso esiste. */
    while ( p != NULL && p->chiave != x ) 
    {
      p = p->prox;
      conta++;
    }
    if ( p == NULL ) /* Non trovato */
      return -1;

    /* Effettuiamo il "salto" e aggiorniamo la testa. */
    if ( p->prox != NULL ) 
      p->prox->prec = p->prec;
    if ( p->prec != NULL )  {
      p->prec->prox = p->prox;
      /* p diventa la nuova testa. */
      p->prec = NULL; 
      p->prox = *testaptr;
      (*testaptr)->prec = p;
      *testaptr = p;
    }
    
    return conta;
}

void stampa(elemento *l)
{
   while ( l != NULL ) 
   {
     printf("%d ", l->chiave);
     l = l->prox;
   }
   printf("\n");
   
}
 
main()
{
  int N, x;
  elemento *lista;

  scanf("%d", &N );
  lista  = leggi_lista(N);

  /*stampa(lista);*/

  while ( 1 )   
  {
     scanf("%d", &x);
     printf("%d\n", mtf(&lista, x));
  }
}
